package lt.zoo;

import lt.zoo.padalinys.*;
import lt.zoo.menu.*;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.IOException;

public class Main
{
    public static void main(String[] args)
    {
		BufferedReader console = new BufferedReader(new InputStreamReader(System.in));
        if (console == null) {
            System.err.println("Klaida: unable to obtain console");
        return;}
        
        String choice="";
        
        // Sukuriame gyvuna - Liutas
        Gyvunas liutas = new Gyvunas( 12, 30, "Liutas", "Plesrunas");
        
        Priziuretojas priziuretojas1 = new Priziuretojas( 15, 1500, "Jonas",
                                                        "Jonaitis", "36501021768", liutas);
        Priziuretojas priziuretojas2 = new Priziuretojas( 15, 1500, "Algirdas",
                                                        "Jonaitytis", "36501021768", liutas);
                                                        
        Lankytojas lankytojas = new Lankytojas("Petras", "Petraitis","36708319238", 30); // Sukuriame lankytoja
       
	//Sukuriame darbuotoja direktorius.
        Administracija direktorius = new Administracija(20, 2500, "Petras", 
                                                        "Petraitis", "38002031982", "aukstasis", "direktorius");
        Padalinys vilniaus = new Padalinys ("Vilnius", "Rojus", direktorius, new Priziuretojas[] {priziuretojas1, priziuretojas2}, 
											new Gyvunas[] {liutas});
        
        Padalinys kauno = new Padalinys ("Kaunas", "Kauno Zoo", direktorius);
        AdminMenu amenu = new AdminMenu(vilniaus);
        UserMenu umenu = new UserMenu(vilniaus);
        GUI gui;
        
	try {
			System.out.println("Iveskite komanda!");
			while (!choice.equals("quit")){
				System.out.println("Komandos: administracijos menu - 'admin_menu', vartotojo menu - 'user_menu', " 
									 + "grafine vartotojo sasaja - 'gui', baigti darba 'quit'");
			    choice = console.readLine();
			    if (choice.equals("admin_menu")) amenu.start(vilniaus);
			    else if (choice.equals("user_menu")) umenu.start(vilniaus);
			    else if (choice.equals("gui")) gui = new GUI(vilniaus);
			    }
		}
	//try {menu.start(kauno, direktorius);}
	catch (AsmensKodoException e) { System.out.println(e + ": " + e.getMsg());}
	catch (Exception e) { System.out.println(e + " Ivedimo/Isvedimo klaida!");}
    }
}
