package lt.zoo.menu;
import lt.zoo.padalinys.*;
import lt.zoo.padalinys.AsmensKodoException;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.IOException;

public class AdminMenu implements Menu
{
	public Padalinys padalinys;
    
    public AdminMenu(Padalinys padalinys)
    {
		this.padalinys=padalinys;
    }
	
    public String priziuretojuSarasas()
    {
		String temp;
        if (padalinys.priziuretojas==null) return "Dirbanciu priziuretoju nera";
        else
        {
            temp = "Priziuretoju sarasas: Vardas - Pavarde - Gyvunas, su kuriuo dirba.\n";
            for (int i=0; i<padalinys.priziuretojas.size(); i++){
            temp = temp + padalinys.priziuretojas.get(i).getVardas()+ " "
                             +padalinys.priziuretojas.get(i).getPavarde()+" "
                             +padalinys.priziuretojas.get(i).getPriziurimasGyvunas().getRusis() + "\n";}      
        }
           return temp;
    }

    public void printDirektoriausInfo(Padalinys padalinys)
    {
        if (padalinys.getDirektorius()==null) System.out.println("Direktoriaus nera");
        else System.out.println("Direktorius "+padalinys.getDirektorius().getVardas() + " "
                                             +padalinys.getDirektorius().getPavarde());
    }

    public String padalinioInfo()
    {
		 if ((padalinys.priziuretojas==null)||(padalinys.gyvunas==null)) return "Dirbanciu priziuretoju arba gyvunu nera";
         else return "Padalinio pavadinimas: "
                            +padalinys.getPavadinimas()+", dirba "
                            +padalinys.priziuretojas.size()+" darbuotojai(u) ir yra "
                            +padalinys.gyvunas.size()+" gyvunai(u).";
    }

    public String gyvunuSarasas()
    {
		String temp;
        if (padalinys.gyvunas==null) return "Gyvunu nera";
        else
        {
            temp = "Gyvunu sarasas: \n";
            for (int i=0; i<padalinys.gyvunas.size(); i++)
            temp += padalinys.gyvunas.get(i).getRusis()+ " Amzius: "
                                      +padalinys.gyvunas.get(i).getAmzius()+". \n";
        }
        return temp;
    }

public void sambdytiPriziuretoja(Padalinys padalinys) throws  AsmensKodoException
    {
        String pasirinkimas="";
        float atlyginimas = 0;
        int patirtis = 0;
        int amzius = 0;
        int gyvenimo_trukme = 0;
        String rusis = "";
        String klase = ""; 
        String vardas = "";
		String pavarde = "";
        String asmens_kodas = "";
	
        BufferedReader console = new BufferedReader(new InputStreamReader(System.in));
        if (console == null) {
            System.err.println("sales: unable to obtain console");
            return;}
        
        
        System.out.println("Iveskite priziuretojo informacija:");
		System.out.println("Iveskite priziuretojo varda:");
        try 
		{
			vardas = console.readLine();
	    }
	    catch(IOException ioerror) 
		{ 
	        System.err.println("Ivedimo klaida!!!");
	        return;
	    }
        
        System.out.println("Iveskite priziuretojo pavarde:");
        try 
		{
			pavarde = console.readLine();
	    }
	    catch(IOException ioerror) 
		{ 
	        System.err.println("Ivedimo klaida!!!");
	        return;
	    }
        
		System.out.println("Iveskite priziuretojo asmens koda:");
        asmens_kodas = console.readLine();
        if (asmens_kodas.length()!= 11) throw new AsmensKodoException("Asmens kodas susideda is 11 simboliu!");
		
		System.out.println("Iveskite priziuretojo atlyginima:");
		pasirinkimas = console.readLine();
		try 
		{
			atlyginimas = Float.parseFloat(pasirinkimas);
	    }
        catch(NumberFormatException exception) 
	    { 
		    System.out.println("Atlyginimas turi buti skaicius!!!"); 
			return; 
		}
        
		System.out.println("Iveskite priziuretojo darbo patirti:");
		pasirinkimas = console.readLine();
		try 
		{
			patirtis = Integer.parseInt(pasirinkimas);
	    }
        catch(NumberFormatException exception) 
	    { 
		    System.out.println("Patirtis turi buti skaicius!!!"); 
			return; 
		}
        
        System.out.println("Iveskite gyvuno, su kuriuo priziuretojas dirbs informacija:");
        
        System.out.println("Iveskite gyvuno amziu:");
		pasirinkimas = console.readLine();
		try 
		{
			amzius = Integer.parseInt(pasirinkimas);
	    }
        catch(NumberFormatException exception) 
	    { 
		    System.out.println("Amzius turi buti skaicius!!!"); 
			return; 
		}
		
		System.out.println("Iveskite gyvuno gyvenimo trukme:");
		pasirinkimas = console.readLine();
		try 
		{
			gyvenimo_trukme = Integer.parseInt(pasirinkimas);
	    }
        catch(NumberFormatException exception) 
	    { 
		    System.out.println("Gyvenimo trukme turi buti skaicius!!!"); 
			return; 
		}
		
		System.out.println("Iveskite gyvuno rusi:");
        try 
		{
			rusis = console.readLine();
	    }
	    catch(IOException ioerror) 
		{ 
	        System.err.println("Ivedimo klaida!!!");
	        return;
	    }
	    
	    System.out.println("Iveskite gyvuno klase:");
        try 
		{
			klase = console.readLine();
	    }
	    catch(IOException ioerror) 
		{ 
	        System.err.println("Ivedimo klaida!!!");
	        return;
	    }
		
        Gyvunas gyvunas = new Gyvunas (amzius, gyvenimo_trukme, rusis, klase);
        padalinys.addGyvunas(gyvunas);
		Priziuretojas priziuretojas = new Priziuretojas(patirtis, atlyginimas, vardas, pavarde, asmens_kodas, gyvunas);
		//System.out.println(jonas.toString());
		padalinys.addPriziuretojas(priziuretojas);
		
	
    }

    public void start(Padalinys padalinys) throws IOException, AsmensKodoException
    {

		String choice="-";
		while (choice.hashCode()!=48)     // != 0;
		{
        BufferedReader console = new BufferedReader(new InputStreamReader(System.in));
        if (console == null) {
            System.err.println("Klaida: unable to obtain console");
            return;}

        System.out.println(" ");
        System.out.println("----------------Trumpas Vartotojo meniu---------------");
        System.out.println("1. Priziuretoju sarasas");
        System.out.println("2. Direktorius");
        System.out.println("3. Padalinio informacija");
        System.out.println("4. Gyvunu sarasas");
        System.out.println("5. Sambdyti nauja darbuotoja");
        //System.out.println("6. Sukurti nauja padalini");
        System.out.println("0. Iseiti");

        choice = console.readLine();

        if (choice.hashCode()==49)      { System.out.println(priziuretojuSarasas()); }   // = 1.
        else if (choice.hashCode()==48) { System.out.println("Pabaiga..."); }      // = 0.
        else if (choice.hashCode()==50) { printDirektoriausInfo(padalinys); }      // = 2.
        else if (choice.hashCode()==51) { System.out.println(padalinioInfo()); }         // = 3.
        else if (choice.hashCode()==52) { System.out.println(gyvunuSarasas()); }         // = 4.
		else if (choice.hashCode()==53) { sambdytiPriziuretoja(padalinys); }
        else { System.out.println("Neteisingas pasirinkimas. Iveskite teisinga skaiciu!"); }

        }
    }
}
