package lt.zoo.padalinys;

import java.util.LinkedList;

public class Padalinys
{
    private String miestas="";
    private String pavadinimas="";
    public Administracija direktorius=null;
    public LinkedList<Lankytojas> lankytojas=null;
    public LinkedList<Priziuretojas> priziuretojas=null;
    public LinkedList<Gyvunas> gyvunas=null;

    public Padalinys(String miestas, String vardas) 
    {
        this.miestas=miestas;
        this.pavadinimas=vardas;
    }

    public Padalinys(String miestas, String vardas, Administracija direktorius)
    {
        this.miestas=miestas;
        this.pavadinimas=vardas;
        this.direktorius=direktorius;
    }

    public Padalinys(String miestas, String vardas, Administracija direktorius,
        Priziuretojas[] priziuretojas, Gyvunas[] gyvunas)
    {
        this.miestas=miestas;
        this.pavadinimas=vardas;
        this.direktorius=direktorius;
        this.priziuretojas=new LinkedList<Priziuretojas>();
        for (Priziuretojas p : priziuretojas)
            this.priziuretojas.addLast(p);
        this.gyvunas=new LinkedList<Gyvunas>();
        for (Gyvunas g : gyvunas)
            this.gyvunas.addLast(g);
    }

    public Padalinys(String miestas, String vardas, Administracija direktorius,
        Priziuretojas[] priziuretojas, Gyvunas[] gyvunas, Lankytojas[] lankytojas)
    {
        this.miestas=miestas;
        this.pavadinimas=vardas;
        this.direktorius=direktorius;
        this.priziuretojas=new LinkedList<Priziuretojas>();
        for (Priziuretojas p : priziuretojas)
            this.priziuretojas.addLast(p);
        this.gyvunas=new LinkedList<Gyvunas>();
        for (Gyvunas g : gyvunas)
            this.gyvunas.addLast(g);
        this.lankytojas=new LinkedList<Lankytojas>();
        for (Lankytojas l : lankytojas)
            this.lankytojas.addLast(l);
    }

    public String getMiestas()
    {
        return miestas;
    }

    public String getPavadinimas()
    {
        return pavadinimas;
    }

    public Administracija getDirektorius()
    {
        return direktorius;
    }

    public void setPavadinimas(String vardas)
    {
        this.pavadinimas=vardas;
    }
    
    public void addGyvunas(Gyvunas gyvunas)
    {
        this.gyvunas.addLast(gyvunas);
    }
    
    public void addPriziuretojas(Priziuretojas priziuretojas)
    {
        this.priziuretojas.addLast(priziuretojas);
    }

    public String toString()
    {
        return ("Padalinys: " + miestas + " " + pavadinimas);
    }
}
